<!-- 分包方资格审批列表 -->
<script lang="ts" setup name="approve">
import type { Ref } from 'vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { DateModelType } from 'element-plus'
import type { IApproveList, IListQueryApprove } from '../subpackage-interface'
import type { IList } from './approve-interface'
import { printJSON } from '@/utils/printUtils'
import { exportFile } from '@/utils/exportUtils'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { getDictByCode } from '@/api/system/dict'
import type { dictType } from '@/views/device/receive/receive'
import type { IMenu } from '@/components/buttonBox/buttonBox'
import ButtonBox from '@/components/buttonBox/buttonBox.vue'
import { deleteListItem, getListPage, submit } from '@/api/business/subpackage/approval'
import { cancelApproval } from '@/api/approval'
import { SCHEDULE } from '@/utils/scheduleDict'
import ApprovalDialog from '@/components/Approval/ApprovalDialog.vue'
import { keepSearchParams, renewSearchParams } from '@/utils/keepQuery'
const approvalDialog = ref() // 审批对话ref
const $router = useRouter()
const $route = useRoute()
const { proxy } = getCurrentInstance() as any
const TabActiveButton = 'SubpackageApproveActive'
const loadingTable = ref(false)
const menu = ref<IMenu[]>([]) // 审批状态按钮组合
const active = ref('')
const timeRange = ref<[DateModelType, DateModelType]>(['', ''])
// 查询条件
const listQuery: Ref<IListQueryApprove> = ref({
  approvalStatus: active.value, // 申请状态, // 申请状态
  formId: SCHEDULE.BUSINESS_SUBPACKAGE_APPROVE, // 表单id
  outsourcerName: '', // 	公司名称
  businessSize: '', //	业务规模-字典code
  evaluation: '', // 	整体评价-字典code
  grade: '', // 	履约评级-字典code
  outsourcerNo: '', // 	分包方编号
  offset: 1,
  limit: 20,
})
// 页面跳转之前保存参数
onBeforeRouteLeave((to: any) => {
  keepSearchParams(to.path, 'subpackage-approve', listQuery.value)
})
// 重新赋值
listQuery.value = renewSearchParams('subpackage-approve') || {
  approvalStatus: active.value, // 申请状态, // 申请状态
  formId: SCHEDULE.BUSINESS_SUBPACKAGE_APPROVE, // 表单id
  outsourcerName: '', // 	公司名称
  businessSize: '', //	业务规模-字典code
  evaluation: '', // 	整体评价-字典code
  grade: '', // 	履约评级-字典code
  outsourcerNo: '', // 	分包方编号
  offset: 1,
  limit: 20,
}
// 表头
const columns = ref<TableColumn[]>([
  { text: '分包方编号', value: 'outsourcerNo', align: 'center', width: '160px' },
  { text: '公司名称', value: 'outsourcerName', align: 'center' },
  { text: '公司规模', value: 'outsourcerSizeName', align: 'center', width: '110' },
  { text: '业务规模', value: 'businessSizeName', align: 'center', width: '130' },
  { text: '履约评级', value: 'gradeName', align: 'center', width: '90' },
  { text: '整体评价', value: 'evaluationName', align: 'center', width: '110' },
  { text: '业务内容', value: 'businessContent', align: 'center' },
  { text: '公司地址', value: 'fullAddress', align: 'center' },
  { text: '创建时间', value: 'createTime', align: 'center', width: '180px' },
  { text: '审批状态', value: 'approvalStatusName', align: 'center', width: '110px' },
])
const list = ref<IList[]>([]) // 表格数据
const total = ref(0) // 数据总条数
const checkoutList = ref<string[]>([]) // 选中的内容
// const companySizeList = ref<dictType[]>([]) // 公司规模列表
const businessSizeList = ref<dictType[]>([]) // 业务规模列表
const gradeList = ref<dictType[]>([]) // 履约评级列表
const evaluationList = ref<dictType[]>([]) // 整体评价列表
const getDict = async () => {
  // 审批状态
  const res = await getDictByCode('approvalStatus')
  // 制作右上角的菜单
  res.data.forEach((item: dictType) => {
    if (item.name === '全部' || item.name === '草稿箱'
      || item.name === '待审批' || item.name === '审批中'
      || item.name === '已通过' || item.name === '未通过'
      || item.name === '已取消') {
      menu.value.push({
        name: item.name,
        id: `${item.value}`,
      })
    }
  })
  // // 获取公司规模
  // getDictByCode('companySize').then((response) => {
  //   companySizeList.value = response.data
  // })
  // 获取业务规模
  getDictByCode('businessSize').then((response) => {
    businessSizeList.value = response.data
  })
  // 获取履约评级
  getDictByCode('grade').then((response) => {
    gradeList.value = response.data
  })
  // 获取整体评价
  getDictByCode('evaluation').then((response) => {
    evaluationList.value = response.data
  })
}

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  // if (!isNowPage) {
  //   // 是否显示当前页，否则跳转第一页
  //   listQuery.value.offset = 1
  // }
  // 模拟数据
  getListPage(listQuery.value).then((response) => {
    list.value = response.data.rows.map((item: { addressProvinceName: string; addressCityName: string }) => {
      return {
        ...item,
        // fullAddress: (item.addressProvinceName === item.addressCityName) ? item.addressCityName : item.addressProvinceName + item.addressCityName,
      }
    })
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}

// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}
// 重置
const clearList = () => {
  listQuery.value = {
    approvalStatus: active.value, // 申请状态, // 申请状态
    formId: SCHEDULE.BUSINESS_SUBPACKAGE_APPROVE, // 表单id
    outsourcerName: '', // 	公司名称
    businessSize: '', //	业务规模-字典code
    evaluation: '', // 	整体评价-字典code
    grade: '', // 	履约评级-字典code
    outsourcerNo: '', // 	分包方编号
    offset: 1,
    limit: 20,
  }
  fetchData()
}

// 搜索
const searchList = () => {
  fetchData(true)
}

// 切换tab状态
const changeCurrentButton = (val: string) => {
  active.value = val
  window.sessionStorage.setItem(TabActiveButton, val)
  // clearList()
  listQuery.value.approvalStatus = active.value
  fetchData(true)
}

// 打印
const printList = () => {
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (checkoutList.value.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '分包方资格审批列表')
  }
  else if (checkoutList.value.length > 0) {
    const printList = list.value.filter((item: IList) => checkoutList.value.includes(item.id))
    printJSON(printList, properties, '分包方资格审批列表')
  }
  else {
    ElMessage.warning('无可打印内容')
  }
}

// 操作
const handleEdit = (row: IList, val: string, title = '') => {
  if (val === '取消') {
    const params = {
      processInstanceId: row.processId!,
      comments: '',
    }
    ElMessageBox.confirm(
      '确认取消该审批吗？',
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    )
      .then(() => {
        cancelApproval(params).then((res) => {
          ElMessage({
            type: 'success',
            message: '取消成功',
          })
          fetchData(true)
        })
      })
  }
  else if (val === '删除') {
    ElMessageBox.confirm(
      '确认删除吗？',
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    )
      .then(() => {
        deleteListItem({ id: row.id }).then((res) => {
          ElMessage({
            type: 'success',
            message: '删除成功',
          })
          fetchData(true)
        })
      })
  }
  else if (val === '提交') {
    ElMessageBox.confirm(
      '确认提交该审批吗？',
      '提示',
      {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning',
      },
    )
      .then(() => {
        submit({ id: row.id, formId: SCHEDULE.BUSINESS_SUBPACKAGE_APPROVE, processId: row.processId }).then((res) => {
          ElMessage({
            type: 'success',
            message: '已提交',
          })
          fetchData(true)
        })
      })
  }
  else if (val === '同意') {
    approvalDialog.value.initDialog('agree', row.taskId, row.decisionItem)
  }
  else if (val === '驳回') {
    approvalDialog.value.initDialog('reject', row.taskId, row.decisionItem)
  }
  else if (val === '拒绝') {
    approvalDialog.value.initDialog('refuse', row.taskId)
  }
  else if (val === 'detail' || val === 'edit') { // 详情和编辑
    $router.push({
      path: `subpackage/qualificationApprove/${val}/${row.id}`,
      query: {
        formId: listQuery.value.formId,
        approvalStatusName: row.approvalStatusName, // 审批状态名称
        processId: row.processId, // 流程实例
        decisionItem: `${row.decisionItem}`, // 控制同意、驳回、拒绝按钮
        taskId: row.taskId, // 任务id，用于审批
      },
    })
  }
}

// 新建
const add = () => {
  $router.push({
    path: 'subpackage/qualificationApprove/add',
  })
}

// 审批结束回调
const approvalSuccess = () => {
  fetchData(true)
}

onMounted(async () => {
  await getDict()
  if (window.sessionStorage.getItem(TabActiveButton)) {
    active.value = window.sessionStorage.getItem(TabActiveButton)!
  }
  else {
    active.value = menu.value.find(item => item.name === '全部')!.id as string // 全部
  }
})
</script>

<template>
  <div>
    <!-- 布局 -->
    <app-container>
      <search-area :need-clear="true" @search="searchList" @clear="clearList">
        <search-item>
          <el-input v-model.trim="listQuery.outsourcerNo" placeholder="分包方编号" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-input v-model.trim="listQuery.outsourcerName" placeholder="公司名称" class="short-input" clearable />
        </search-item>
        <search-item>
          <el-select v-model="listQuery.businessSize" style="width: 200px;" placeholder="业务规模" clearable>
            <el-option v-for="item in businessSizeList" :key="item.id" :label="item.name" :value="item.value" />
          </el-select>
        </search-item>
        <search-item>
          <el-select v-model="listQuery.grade" style="width: 200px;" placeholder="履约评级" clearable>
            <el-option v-for="item in gradeList" :key="item.id" :label="item.name" :value="item.value" />
          </el-select>
        </search-item>
        <search-item>
          <el-select v-model="listQuery.evaluation" style="width: 200px;" placeholder="整体评价" clearable>
            <el-option v-for="item in evaluationList" :key="item.id" :label="item.name" :value="item.value" />
          </el-select>
        </search-item>
      </search-area>
      <table-container>
        <template #btns-right>
          <icon-button icon="icon-add" title="新建" type="primary" @click="add" />
          <icon-button icon="icon-print" title="打印" type="primary" @click="printList" />
        </template>
        <normal-table
          :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="loadingTable"
          is-showmulti-select @change="changePage" @multi-select="handleSelectionChange"
        >
          <template #preColumns>
            <el-table-column label="序号" width="55" align="center">
              <template #default="scope">
                {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
              </template>
            </el-table-column>
          </template>
          <template #columns>
            <el-table-column
              label="操作"
              align="center"
              fixed="right"
              :width="(active === '0') ? 150 : (active === '1' || active === '6' || active === '3') ? 150 : (active === '4' || active === '5') ? 100 : 150"
            >
              <template #default="{ row }">
                <el-button
                  size="small"
                  type="primary"
                  link
                  @click="handleEdit(row, 'detail')"
                >
                  查看
                </el-button>
                <el-button
                  v-if=" row.approvalStatusName === '待审批'"
                  size="small"
                  link
                  type="primary"
                  :disabled="row.approvalStatusName !== '待审批' && row.approvalStatusName !== '审批中'"
                  @click="handleEdit(row, '同意')"
                >
                  同意
                </el-button>
                <el-button
                  v-if=" row.approvalStatusName === '待审批' && row.decisionItem !== 3"
                  size="small"
                  link
                  type="primary"
                  :disabled="row.approvalStatusName !== '待审批' && row.approvalStatusName !== '审批中'"
                  @click="handleEdit(row, '驳回')"
                >
                  驳回
                </el-button>
                <el-button
                  v-if=" row.approvalStatusName === '待审批' && row.decisionItem !== 2"
                  size="small"
                  link
                  type="danger"
                  :disabled="row.approvalStatusName !== '待审批' && row.approvalStatusName !== '审批中'"
                  @click="handleEdit(row, '拒绝')"
                >
                  拒绝
                </el-button>
                <el-button
                  v-if="(row.approvalStatusName === '未通过-驳回') || row.approvalStatusName === '草稿箱' || row.approvalStatusName === '已取消'"
                  size="small"
                  link
                  type="primary"
                  @click="handleEdit(row, 'edit')"
                >
                  编辑
                </el-button>
                <el-button
                  v-if="row.approvalStatusName === '草稿箱' || row.approvalStatusName === '已取消'"
                  size="small"
                  link
                  type="primary"
                  @click="handleEdit(row, '提交')"
                >
                  提交
                </el-button>

                <!-- 是发起者且审批中可以取消 -->
                <el-button
                  v-if="row.approvalStatusName === '审批中'"
                  size="small"
                  link
                  type="info"
                  :disabled="row.approvalStatusName !== '审批中'"
                  @click="handleEdit(row, '取消')"
                >
                  取消
                </el-button>
                <!-- 发起者和有删除权限的可以删除，已通过未通过状态不可以删除 -->
                <!-- <el-button
                v-if="row.approvalStatusName !== '未通过' && row.approvalStatusName !== '已通过' && row.approvalStatusName !== '未通过-驳回'"
                size="small"
                link
                type="danger"
                :disabled="row.approvalStatusName === '未通过' || row.approvalStatusName === '已通过'"
                 @click="handleEdit(row, '删除')"
              >
                删除
              </el-button> -->
                <!-- ---------------------------审批中的删除按钮暂时去掉------------------------ -->
                <el-button
                  v-if="row.approvalStatusName !== '未通过' && row.approvalStatusName !== '已通过' && row.approvalStatusName !== '未通过-驳回' && row.approvalStatusName !== '审批中' && row.approvalStatusName !== '待审批'"
                  size="small"
                  link
                  type="danger"
                  :disabled="row.approvalStatusName === '未通过' || row.approvalStatusName === '已通过'"
                  @click="handleEdit(row, '删除')"
                >
                  删除
                </el-button>
              </template>
            </el-table-column>
          </template>
        </normal-table>
      </table-container>
      <!-- 审批弹窗 -->
      <approval-dialog ref="approvalDialog" @on-success="approvalSuccess" />

      <button-box :active="active" :menu="menu" @change-current-button="changeCurrentButton" />
    </app-container>
  </div>
</template>
